//---------------------------------------------------------------------------

#include <vcl.h>
#include "ITSSkinF.h"
#include "ITSUtilF.h"
#include "AppGlobalF.h"
#include "ITSLangTransF.h"
#include "ITSMapF.h"
#include "WindowMsgF.h"
#include "ITS_OPLibF.h"
#pragma hdrstop

#include "VDSM100MF.h"
#include "VDSM101MF.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cxButtons"
#pragma link "cxClasses"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxCustomData"
#pragma link "cxData"
#pragma link "cxDataStorage"
#pragma link "cxDropDownEdit"
#pragma link "cxEdit"
#pragma link "cxFilter"
#pragma link "cxGraphics"
#pragma link "cxGrid"
#pragma link "cxGridCustomTableView"
#pragma link "cxGridCustomView"
#pragma link "cxGridLevel"
#pragma link "cxGridTableView"
#pragma link "cxGroupBox"
#pragma link "cxLabel"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxMaskEdit"
#pragma link "cxSpinEdit"
#pragma link "cxSplitter"
#pragma link "cxStyles"
#pragma link "cxTextEdit"
#pragma link "dxSkinBlue"
#pragma link "dxSkinsCore"
#pragma link "dxSkinscxPCPainter"
#pragma link "FRAME_OpenMapF"
#pragma link "FRAME_VdsListF"
#pragma link "dxSkinBlack"
#pragma link "dxSkinMcSkin"
#pragma resource "*.dfm"

TVDSM100M *VDSM100M = NULL;
//---------------------------------------------------------------------------
void TVDSM100M_MapCallback(TObject *ASender, const String AFunc, const String AArgs, const bool AFirst)
{
    try
    {
        if (!VDSM100M) return;
        VDSM100M->OpenMapCallback(ASender, AFunc, AArgs, AFirst);
    }
    catch(Exception &exception)
    {
    }
}
//---------------------------------------------------------------------------

__fastcall TVDSM100M::TVDSM100M(TComponent* Owner)
    : TForm(Owner)
{
    LangTrans->Translate(this, ITSDb_GetConnection());
    ITSSkin_Load(this);
    CMM_LoadForm(g_sFormsDir, this);

    FUpdate= false;
    FTitle = Caption;//"VDS 기본정보 관리";

    FRAMEVdsList1->PnlTop->Visible = false;
    FRAMEVdsList1->PnlBottom->Visible = false;
    FRAMEVdsList1->ColumnSel->Visible = false;

    m_pGDC = FRAMEVdsList1->TvList->DataController;

    FLayerIdx = LyrTp_Vds;
    FRAMEOpenMap1->LayerIdx = FLayerIdx;
    FRAMEOpenMap1->MapCallbackFunc = TVDSM100M_MapCallback;

    EditMode = false;
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::CommClose()
{
    try
    {
        CMM_SaveForm(g_sFormsDir, this);
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::FormShow(TObject *Sender)
{
    Refresh();

    FRAMEOpenMap1->OpenMap();

    APP_FillCode(CbType, "VDST");
    APP_FillCode(Cb_CMRA_DRCT_CD, "VDSC");

    VdsCtlrManager->FLists.Lock();
    try
    {
        FOR_STL(TVdsCtlr*, pObj, VdsCtlrManager->FLists)
        {
            if (pObj->DEL_YN == "Y") continue;
            pObj->FData3 = NULL;
        }
    }
    __finally
    {
        VdsCtlrManager->FLists.UnLock();
    }

    FormInit();
    ChangeEditMode(1);
    TmrShow->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::FormInit()
{
	EdNmbr->Text = "";
    EdVdsId->Text = "";
	EdVdsNm->Text = "";

	CbType->ItemIndex = 0;

    SePosX->Value = 0;
    SePosY->Value = 0;

    EdCtlrIp->Text = "";
    EdCmncPort->Text = "";

    SeBordNum->Value         = 1;
    Se_GROUP_NO->Value       = 1;
    Se_LOCAL_NO->Value       = 1;
    Se_TRAF_CLCT_CYCL->Value = 60;
    Se_STTS_CLCT_CYCL->Value = 60;

    Ed_ISTL_LCTN_NM->Text = "";
    ISTL_LCTN_ADDR->Text = "";

    CMM_ClearGridTableView(TvCmra);
    FNewDb = false;
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::TmrShowTimer(TObject *Sender)
{
    TmrShow->Enabled = false;
    FRAMEVdsList1->UpdateList();
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::BtnCloseClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::FormClose(TObject *Sender, TCloseAction &Action)
{
    CommClose();
    VDSM100M = NULL;
    Action = caFree;
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    if (FUpdate)
    {
        POST_MSG(Application->MainForm->Handle, WM_DATABASE_REFRESH, WP_MSG_14, 0);
    }

    FRAMEVdsList1->OnCloseQuery(CanClose);
    FRAMEOpenMap1->OnCloseQuery(CanClose);
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::DisplayInfo(TVdsCtlr* AObj, bool AMoveObj/*=true*/)
{
    FormInit();

    if (!AObj) return;

    if (AMoveObj)
    {
        sJs.printf(L"selectLayerObject(%d, '%s', %d)", FLayerIdx, AObj->VDS_CTLR_NMBR.c_str(), FRAMEOpenMap1->MapZoom);
        FRAMEOpenMap1->ExecScript(sJs);
    }
	EdNmbr->Text  = String(AObj->VDS_CTLR_NMBR);
    EdVdsId->Text = AObj->VDS_CTLR_ID;
	EdVdsNm->Text = AObj->VDS_NM;

	APP_SetCode(CbType, AObj->VDS_TYPE_CD);

    SePosX->Value = AObj->X_CRDN;
    SePosY->Value = AObj->Y_CRDN;

    EdCtlrIp->Text = AObj->VDS_CTLR_IP;
    //EdCmncPort->Text = AObj->VDS_CTLR_PORT;

    SeBordNum->Value         = AObj->DETECT_LANES;
    Se_GROUP_NO->Value       = AObj->GROUP_NO;
    Se_LOCAL_NO->Value       = AObj->VDS_CTLR_LOCAL_NO;
    Se_TRAF_CLCT_CYCL->Value = AObj->TRAF_CLCT_CYCL;
    Se_STTS_CLCT_CYCL->Value = AObj->STTS_CLCT_CYCL;

    Ed_ISTL_LCTN_NM->Text    = AObj->ISTL_LCTN_NM;
    ISTL_LCTN_ADDR->Text     = AObj->ISTL_LCTN_ADDR;

//    FRAMEGisMap1->SelectObjectByPos(SePosX->Value, SePosY->Value, true);

    DisplayCmra(AObj);

    ChangeEditMode(3);
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::UpdateIcon()
{
    if (!FRAMEOpenMap1->MapStart) return;

    sJs.printf(L"removeLayerObject(%d)", FLayerIdx);
    FRAMEOpenMap1->ExecScript(sJs);

    String arrObj = "";
    String sTemp;

    VdsCtlrManager->FLists.Lock();
    try
    {
        FOR_STL(TVdsCtlr*, pObj, VdsCtlrManager->FLists)
        {
            if (pObj->DEL_YN == "Y") continue;

            if (arrObj != "") arrObj += "|";

            sTemp.printf(L"%s,%s,%s,%.6f,%.6f,0,0,0,0", pObj->VDS_CTLR_NMBR.c_str(), pObj->VDS_CTLR_ID.c_str(), pObj->VDS_NM.c_str(), pObj->X_CRDN, pObj->Y_CRDN);
            arrObj += sTemp;
        }
    }
    __finally
    {
        VdsCtlrManager->FLists.UnLock();
        if (arrObj != "")
        {
            sJs.printf(L"addFacility(%d, '%s')", FLayerIdx, arrObj.c_str());
            FRAMEOpenMap1->ExecScript(sJs);
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::BtnEditClick(TObject *Sender)
{
    String sId = EdNmbr->Text;
    TVdsCtlr *pObj = VdsCtlrManager->FLists.Find(sId);

    FNewDb = false;

    if (BtnEdit->Caption == FrmLang->lblEdit->Caption)//"편집")
    {
        //편집모드 시작
        ChangeEditMode(0);
        if (pObj)
        {
            //시설물아이콘을 편집아이콘으로 변경
            //function editFacilityObject(ALyrIdx, ANmbr, AComm(0:오류-편집,1:정상), AEdit(편집모드:1-편집,0-편집취소))
            sJs.printf(L"editFacilityObject(%d, %s, 1, 1)", FLayerIdx, pObj->VDS_CTLR_NMBR.c_str());
            FRAMEOpenMap1->ExecScript(sJs);
        }
    }
    else
    {
        //편집모드 취소
        ChangeEditMode(1);
        if (pObj)
        {
            //원래 정보를 화면에 표출
            CMM_SetGridRow(FRAMEVdsList1->CxList, FRAMEVdsList1->TvList, sId, FRAMEVdsList1->Column01->Index);
            DisplayInfo(pObj, false);

#if 0
            //지도시설물아이콘을 원래아이콘으로 변경
            sJs.printf(L"editFacilityObject(%d, %s, 0, 0)", FLayerIdx, pObj->VDS_CTLR_NMBR.c_str());
            FRAMEOpenMap1->ExecScript(sJs);
#else
            //추가 모드에서 취소하는 경우 지도에 신규로 추가한 객체를 찾아서 삭제해 주는것 보다
            //새롭게 다시 그리자
            UpdateIcon();
#endif
        }
        else
        {
            //객체가 없는 경우는 추가 모드에서 취소한 경우임
            sJs.printf(L"removeFacilityObject(%d, %s)", FLayerIdx, sId.c_str());
            FRAMEOpenMap1->ExecScript(sJs);
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::ChangeEditMode(int AEdit)
{
    bool bEnabled = false;
    switch(AEdit)
    {
    case 0: //편집버튼클릭
        {
            BtnEdit->Enabled = true;
            BtnInsert->Enabled = false;
            BtnDelete->Enabled = false;
            BtnSave->Enabled = true;

            BtnEdit->Caption = FrmLang->lblCancel->Caption;//"취소";
            BtnEdit->Hint    = FrmLang->lblCancel->Hint;//데이터 편집 취소";
            EditMode = true;
        }
        break;
    case 1: //편집[취소]버튼클릭
        {
            FormInit(); //화면을 모두 지운다.
            BtnEdit->Enabled = false;
            BtnInsert->Enabled = true;
            BtnDelete->Enabled = false;
            BtnSave->Enabled = false;

            BtnEdit->Caption = FrmLang->lblEdit->Caption;//"편집";
            BtnEdit->Hint    = FrmLang->lblEdit->Hint;//데이터 편집";
            //bEnabled = true;
            EditMode = false;
        }
        break;
    case 2: //추가
        {
            BtnEdit->Enabled = true;
            BtnInsert->Enabled = false;
            BtnDelete->Enabled = false;
            BtnSave->Enabled = true;

            BtnEdit->Caption = FrmLang->lblCancel->Caption;//"취소";
            BtnEdit->Hint    = FrmLang->lblCancel->Hint;//데이터 편집 취소";
            EditMode = true;
        }
        break;
    case 3: //수정모드
        {
            BtnEdit->Enabled = true;
            BtnInsert->Enabled = true;
            BtnDelete->Enabled = true;
            BtnSave->Enabled = false;

            BtnEdit->Caption = FrmLang->lblEdit->Caption;//"편집";
            BtnEdit->Hint    = FrmLang->lblEdit->Hint;//데이터 편집";
            bEnabled = true;
            EditMode = false;
        }
        break;
    }

    if (AEdit == 0 || AEdit == 2)
    {
        FRAMEVdsList1->CxList->Enabled = false;
    }
    else
    {
        FRAMEVdsList1->CxList->Enabled = true;
    }

    PnlEdit->Enabled = EditMode;
}
//---------------------------------------------------------------------------


void __fastcall TVDSM100M::BtnInsertClick(TObject *Sender)
{
    FormInit();
    //신규아이디를 얻어와서 화면을 초기화한다.

    int nNmbr, nId;
    if (!VdsCtlrManager->GetNextVdsId(nNmbr, nId))
    {
        Application->MessageBox(lblText1->Caption.c_str(),//L"새로운 VDS 정보를 생성하지 못하였습니다.\r\n프로그램 종료후에 다시 시도해 보세요.",
                                FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
        return;
    }

    EdNmbr->Text = String(nNmbr);
    SePosX->Value = FRAMEOpenMap1->CenterX;
    SePosY->Value = FRAMEOpenMap1->CenterY;

    //지도에 새로운 시설물 아이콘 추가하면서 편집모드로 변경
    String arrObj = "";
    arrObj.printf(L"%d,New,New,%.6f,%.6f,1", nNmbr, FRAMEOpenMap1->CenterX, FRAMEOpenMap1->CenterY);
    sJs.printf(L"addFacilityObject(%d, '%s')", FLayerIdx, arrObj.c_str());
    FRAMEOpenMap1->ExecScript(sJs);

    ChangeEditMode(2);
    FNewDb = true;
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::BtnDeleteClick(TObject *Sender)
{
    if (!FRAMEOpenMap1->MapStart) return;

    int nIdx = m_pGDC->FocusedRecordIndex;
    if (nIdx < 0) return;

    String sId = EdNmbr->Text;

    if (sId.IsEmpty())
    {
        Application->MessageBox(lblText2->Caption.c_str(),//L"삭제할 VDS를 목록에서 선택하세요.\r\n목록에서 더블클릭하여 선택합니다.",
                                FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
        return;
    }

    String sMsg;
    sMsg = lblText3->Caption + ": " + sId;//"VDS번호: " + sId;
    sMsg+= "\r\n" + lblText4->Caption;//"선택하신 VDS 정보를 삭제하시겠습니까?";

    if (Application->MessageBox(sMsg.c_str(), FTitle.c_str(), MB_YESNO|MB_ICONQUESTION|MB_APPLMODAL) != IDYES) return;

	TVdsCtlr *pObj = VdsCtlrManager->FLists.Find(sId);

	if (pObj)
	{
		if (VdsCtlrManager->DeleteVds(pObj))
		{
            pObj->DEL_YN = "Y";
            FRAMEVdsList1->UpdateList();
            UpdateIcon();
		}

        FUpdate = true;

        Application->MessageBox(lblText5->Caption.c_str(),//L"VDS 정보삭제\r\nVDS 정보를 삭제 하였습니다.",
                                FTitle.c_str(), MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);

        FormInit();
        ChangeEditMode(1);

        UpdateIcon();
	}
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::BtnSaveClick(TObject *Sender)
{
	if (EdNmbr->Text.IsEmpty()          ||
        EdVdsId->Text.Trim().IsEmpty() ||
        EdVdsNm->Text.Trim().IsEmpty() ||
        SePosX->Value == 0              ||
        SePosY->Value == 0              ||
        CbType->Text.IsEmpty()          ||
        EdCtlrIp->Text.IsEmpty())
	{
        Application->MessageBox(FrmLang->lblNecessary->Caption.c_str(),//L"★항목은 필수 입력 항목입니다.\r\n모두 입력후 진행해 주세요.",
                                FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
		return;
	}

    String sNmbr = EdNmbr->Text;
    int    nNmbr = sNmbr.ToInt();
    String sVdsId = EdVdsId->Text.Trim();

    if (!ITSUtil_CheckIpAddress(EdCtlrIp->Text.Trim()))
    {
        Application->MessageBox(lblText6->Caption.c_str(),//L"제어기 IP가 유효하지 않습니다.",
                                FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
		return;
    }

    VdsCtlrManager->FLists.Lock();
    FOR_STL(TVdsCtlr*, pTmpObj, VdsCtlrManager->FLists)
    {
        if (pTmpObj->DEL_YN == "Y") continue;
        if (pTmpObj->VDS_CTLR_NMBR == nNmbr) continue; //자기자신

        if (pTmpObj->VDS_CTLR_ID == sVdsId)
        {
            Application->MessageBox(lblText8->Caption.c_str(),//L"VDS ID가 이미 사용 중입니다. VDS ID를 확인하세요.",
                                    FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
            VdsCtlrManager->FLists.UnLock();
            return;
        }
    }
    VdsCtlrManager->FLists.UnLock();

    TVdsCtlr *pObj;
    if (FNewDb)
        pObj = new TVdsCtlr();
    else
        pObj = VdsCtlrManager->FLists.Find(sNmbr);

    if (pObj)
    {
        pObj->VDS_CTLR_NMBR = nNmbr;
        pObj->VDS_CTLR_ID   = sVdsId;
        pObj->VDS_NM        = EdVdsNm->Text.Trim();

        pObj->VDS_CTLR_IP       = EdCtlrIp->Text;
        pObj->VDS_CTLR_PORT     = EdCmncPort->Text.ToIntDef(0);
        pObj->VDS_CTLR_LOCAL_NO = Se_LOCAL_NO->Value;

        pObj->VDS_TYPE_CD  = APP_GetCode(CbType);
        pObj->ISTL_LCTN_NM = Ed_ISTL_LCTN_NM->Text.Trim();
        pObj->ISTL_LCTN_ADDR = ISTL_LCTN_ADDR->Text.Trim();

        pObj->X_CRDN = SePosX->Value;
        pObj->Y_CRDN = SePosY->Value;

        pObj->DETECT_LANES   = SeBordNum->Value;
        pObj->GROUP_NO       = Se_GROUP_NO->Value;
        pObj->TRAF_CLCT_CYCL = Se_TRAF_CLCT_CYCL->Value;
        pObj->STTS_CLCT_CYCL = Se_STTS_CLCT_CYCL->Value;

        pObj->TRAF_CLCT_CYCL = 60;
        pObj->STTS_CLCT_CYCL = 60;

        pObj->Completed    = true;
        pObj->MEM_DEL      = "N";

        bool bResult;
        if (FNewDb)
        {
            pObj->DEL_YN = "N";
            bResult = VdsCtlrManager->InsertVds(pObj);
            if (bResult)
            {
                VdsCtlrManager->FLists.Push(sNmbr, pObj);
            }
		}
        else
		{
            bResult = VdsCtlrManager->UpdateVds(pObj);
		}

        if (bResult)
        {
            Application->MessageBox(lblText9->Caption.c_str(),//L"VDS 정보저장\r\nVDS 정보를 저장 하였습니다.",
                                    FTitle.c_str(), MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);

            FUpdate = true;

            FRAMEVdsList1->UpdateList();
            UpdateIcon();
            CMM_SetGridRow(FRAMEVdsList1->CxList, FRAMEVdsList1->TvList, sNmbr, FRAMEVdsList1->Column01->Index);
            DisplayInfo(pObj, true);
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::FRAMEVdsList1TvListCellDblClick(TcxCustomGridTableView *Sender,
          TcxGridTableDataCellViewInfo *ACellViewInfo, TMouseButton AButton,
          TShiftState AShift, bool &AHandled)
{
	if (!ACellViewInfo) return;
	int nRow = FRAMEVdsList1->TvList->DataController->FocusedRecordIndex;
	if( nRow <= -1 )
		return;

    int nMemPtr = FRAMEVdsList1->TvList->DataController->Values[nRow][FRAMEVdsList1->Column99->Index];
    TVdsCtlr* pObj = (TVdsCtlr*)nMemPtr;
    DisplayInfo(pObj, true);
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::Ed_VDS_PORTKeyPress(TObject *Sender, wchar_t &Key)
{
    if (Key > '9' || Key < '0')
    {
        if (Key != VK_BACK && Key != VK_TAB && Key != '-')
            Key = 0;
    }
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::Se_VDS_CHNLPropertiesChange(TObject *Sender)
{
    if (((TcxSpinEdit*)Sender)->Value < ((TcxSpinEdit*)Sender)->Properties->MinValue)
        ((TcxSpinEdit*)Sender)->Value = ((TcxSpinEdit*)Sender)->Properties->MinValue;
    else if(((TcxSpinEdit*)Sender)->Value > ((TcxSpinEdit*)Sender)->Properties->MaxValue &&
        ((TcxSpinEdit*)Sender)->Properties->MaxValue)
        ((TcxSpinEdit*)Sender)->Value = ((TcxSpinEdit*)Sender)->Properties->MaxValue;
}
//---------------------------------------------------------------------------
void __fastcall TVDSM100M::OpenMapCallback(TObject *ASender, const String AFunc, const String AArgs, const bool AFirst)
{
    try
    {
        if (AFirst)
        {
            //지도를 편집모드로 변경
            sJs.printf(L"setEditMode(%d, 1)", FLayerIdx);
            FRAMEOpenMap1->ExecScript(sJs);

            //시설물아이콘 등록
            UpdateIcon();

            sJs.printf(L"extentLayer(%d)", FLayerIdx);
            FRAMEOpenMap1->ExecScript(sJs);
            return;
        }

        if (AFunc.Pos("onfacilitydragend"))
        {
            TStringList *pStringList = new TStringList;
            pStringList->CommaText = AArgs;

            try
            {
                String sNmbr      = pStringList->Strings[0];
                String sCenterLat = pStringList->Strings[1];
                String sCenterLng = pStringList->Strings[2];
                SePosX->Value = sCenterLat.ToDouble();
                SePosY->Value = sCenterLng.ToDouble();
            }
            catch(Exception &e)
            {
            }
            delete pStringList;
        }
    }
    catch(Exception &exception)
    {
    }
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::BtnListAddClick(TObject *Sender)
{
    //카메라 등록
    String sId = EdNmbr->Text;
	TVdsCtlr *pObj = VdsCtlrManager->FLists.Find(sId);
    if (!pObj) return;

    try {
        TVDSM101M *pDlg = new TVDSM101M(this);
        pDlg->ShowModal();
        if (pDlg->FUpdated)
        {
            int    VDS_CMRA_NO  = pDlg->Se_VDS_CMRA_NO->Value;
            int    DETECT_LANE  = pDlg->Se_DETECT_LANE->Value;
            String VDS_CMRA_NM  = pDlg->EdCmraNm->Text.Trim();
            String CMRA_DRCT_CD = APP_GetCode(pDlg->Cb_CMRA_DRCT_CD);
            String CCAM_CTLR_NMBR = pDlg->GetCCAM_NMBR();
            String ROAD_NAME      = pDlg->Ed_ROAD_NAME->Text.Trim();
            String CROSS_NAME     = pDlg->Ed_CROSS_NAME->Text.Trim();
            String DIR_NAME       = pDlg->Ed_DIR_NAME->Text.Trim();

            TVdsCmra *pCmra = pObj->FCmras.Find(VDS_CMRA_NO);
            if (!pCmra)
            {
                pCmra = new TVdsCmra();
                pCmra->VDS_CMRA_NO = VDS_CMRA_NO;
                pObj->FCmras.Push(pCmra->VDS_CMRA_NO, pCmra);
            }

            pCmra->VDS_CTLR_NMBR  = pObj->VDS_CTLR_NMBR;
            pCmra->VDS_CMRA_NM    = VDS_CMRA_NM;
            pCmra->DETECT_LANE    = DETECT_LANE;
            pCmra->CMRA_DRCT_CD   = CMRA_DRCT_CD;
            pCmra->CCAM_CTLR_NMBR = CCAM_CTLR_NMBR;
            pCmra->ROAD_NAME      = ROAD_NAME;
            pCmra->CROSS_NAME     = CROSS_NAME;
            pCmra->DIR_NAME       = DIR_NAME;
            pCmra->DEL_YN         = "N";

            DisplayCmra(pObj);
        }
        delete pDlg;
    } catch(...) { }
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::BtnListDeleteClick(TObject *Sender)
{
    //카메라 삭제
    String sId = EdNmbr->Text;
	TVdsCtlr *pObj = VdsCtlrManager->FLists.Find(sId);
    if (!pObj) return;

	int nRow = TvCmra->DataController->FocusedRecordIndex;
	if( nRow <= -1 )
		return;

    String VDS_CMRA_NO = VarToStr(TvCmra->DataController->Values[nRow][ColCmra1->Index]);
    TVdsCmra *pCmra = pObj->FCmras.Find(VDS_CMRA_NO.ToIntDef(0));
    if (pCmra)
    {
        pCmra->DEL_YN = "N";
        DisplayCmra(pObj);
    }
}
//---------------------------------------------------------------------------

void __fastcall TVDSM100M::DisplayCmra(TVdsCtlr* AObj)
{
    if (!AObj) return;

    CMM_ClearGridTableView(TvCmra);

    int nRow;
    TvCmra->BeginUpdate();
    TcxDataController *pGDC = TvCmra->DataController;
    try {
        FOR_STL(TVdsCmra*, pObj, AObj->FCmras)
        {
            if (pObj->DEL_YN == "Y") continue;

            nRow = pGDC->AppendRecord();
            pGDC->Values[nRow][ColCmra1->Index] = String(pObj->VDS_CMRA_NO);
            pGDC->Values[nRow][ColCmra2->Index] = APP_GetCodeName(Cb_CMRA_DRCT_CD, pObj->CMRA_DRCT_CD);
            pGDC->Values[nRow][ColCmra3->Index] = String(pObj->DETECT_LANE);
            pGDC->Values[nRow][ColCmra4->Index] = pObj->VDS_CMRA_NM;
            pGDC->Values[nRow][ColCmra5->Index] = pObj->CCAM_CTLR_NMBR;
            pGDC->Values[nRow][ColCmra6->Index] = pObj->ROAD_NAME;
            pGDC->Values[nRow][ColCmra7->Index] = pObj->CROSS_NAME;
            pGDC->Values[nRow][ColCmra8->Index] = pObj->DIR_NAME;
        }
    }
    __finally
    {
        TvCmra->EndUpdate();
    }
}
//---------------------------------------------------------------------------

